﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;

namespace AutoReset
{
    class Account { 
  //      public AutoResetEvent a = new AutoResetEvent(false);
        public ManualResetEvent a = new ManualResetEvent(false);
        public void Radi()
        {
            Console.WriteLine("{0} poceo cekanje", Thread.CurrentThread.Name);
            a.WaitOne(3000);
            Thread.Sleep(200);
            Console.WriteLine("{0} zavrsio cekanje", Thread.CurrentThread.Name);
            a.WaitOne(3000);
            Console.WriteLine("{0} zavrsio 2 cekanje", Thread.CurrentThread.Name); 
        }
    } 
    class Program { 
        static void Main() {
            Thread[] threads = new Thread[10]; 
            Account acc = new Account(); // acc će biti zajednički objekt
            for (int i = 0; i < 2; i++) {
                Thread t = new Thread(new ThreadStart(acc.Radi));
                t.Name = i.ToString();
                threads[i] = t; 
            } 
            for (int i = 0; i < 2; i++) { 
                threads[i].Start(); 
            } 
            Console.WriteLine("threadovi zapoceli"); 
            acc.a.Set(); 
            Thread.Sleep(100);
            acc.a.Set();
            acc.a.Reset();
        }
    }
}
